#if !defined(__FLLOPQP_H)
#define	__FLLOPQP_H
#include "fllopqppf.h"

typedef struct _p_QP* QP;

FLLOP_EXTERN PetscClassId QP_CLASSID;

FLLOP_EXTERN PetscErrorCode QPCreate(MPI_Comm comm,QP *qp);
FLLOP_EXTERN PetscErrorCode QPDuplicate(QP qp1,QP *qp2);
FLLOP_EXTERN PetscErrorCode QPView(QP qp,PetscViewer v);
FLLOP_EXTERN PetscErrorCode QPDestroy(QP *qp);

FLLOP_EXTERN PetscErrorCode QPGetVecs(QP qp,Vec *right,Vec *left);

FLLOP_EXTERN PetscErrorCode QPSetInitialVector(QP qp,Vec x);
FLLOP_EXTERN PetscErrorCode QPSetOperator(QP qp,Mat A);
FLLOP_EXTERN PetscErrorCode QPSetPCOperator(QP qp,Mat pmat);
FLLOP_EXTERN PetscErrorCode QPSetOperatorNullSpace(QP qp,Mat R);
FLLOP_EXTERN PetscErrorCode QPSetRhs(QP qp,Vec b);
FLLOP_EXTERN PetscErrorCode QPSetIneq(QP qp, Mat Bineq, Vec cineq);
FLLOP_EXTERN PetscErrorCode QPSetEq(QP qp, Mat Beq, Vec ceq);
FLLOP_EXTERN PetscErrorCode QPSetBox(QP qp, Vec lb, Vec ub);
FLLOP_EXTERN PetscErrorCode QPSetFromOptions(QP qp);

FLLOP_EXTERN PetscErrorCode QPGetSolutionVector(QP qp,Vec *x);
FLLOP_EXTERN PetscErrorCode QPGetOperator(QP qp,Mat *A);
FLLOP_EXTERN PetscErrorCode QPGetPCOperator(QP qp,Mat *pmat);
FLLOP_EXTERN PetscErrorCode QPGetOperatorNullSpace(QP qp,Mat *R);
FLLOP_EXTERN PetscErrorCode QPGetRhs(QP qp,Vec *b);
FLLOP_EXTERN PetscErrorCode QPGetIneq(QP qp, Mat *Bineq, Vec *cineq);
FLLOP_EXTERN PetscErrorCode QPGetEq(QP qp, Mat *Beq, Vec *ceq);
FLLOP_EXTERN PetscErrorCode QPGetBox(QP qp, Vec *lb, Vec *ub);
FLLOP_EXTERN PetscErrorCode QPGetQPPF(QP qp, QPPF *pf);

FLLOP_EXTERN PetscErrorCode QPSetChangeListener(QP qp,PetscErrorCode (*f)(QP));
FLLOP_EXTERN PetscErrorCode QPSetChangeListenerContext(QP qp,void *ctx);
FLLOP_EXTERN PetscErrorCode QPGetChangeListener(QP qp,PetscErrorCode (**f)(QP));
FLLOP_EXTERN PetscErrorCode QPGetChangeListenerContext(QP qp,void *ctx);

FLLOP_EXTERN PetscErrorCode QPAddChild(MPI_Comm comm, QP qp, QP *newchild);
FLLOP_EXTERN PetscErrorCode QPGetChild(QP qp,QP *child);
FLLOP_EXTERN PetscErrorCode QPGetLast(QP qp,QP *child);
FLLOP_EXTERN PetscErrorCode QPFindChild(QP qp,void(*transform)(void),QP *child);
FLLOP_EXTERN PetscErrorCode QPGetParent(QP qp,QP *parent);
FLLOP_EXTERN PetscErrorCode QPGetPostSolve(QP qp, PetscErrorCode (**f)(QP child,Vec x_parent));
FLLOP_EXTERN PetscErrorCode QPGetTransform(QP qp,void(**f)(void));

FLLOP_EXTERN PetscErrorCode QPEnforceEq(QP qp,PetscBool useP,PetscReal rho);
FLLOP_EXTERN PetscErrorCode QPHomogenizeEq(QP qp);
FLLOP_EXTERN PetscErrorCode QPDualize(QP qp, MatInvType invType);
FLLOP_EXTERN PetscErrorCode QPRegularize(QP qp,PetscBool explicitly);
FLLOP_EXTERN PetscErrorCode QPFetiPrepare(QP qp,PetscBool regularize);

#endif
