#if !defined(__FLLOPQPPF_H)
#define __FLLOPQPPF_H
#include "fllopmat.h"

FLLOP_EXTERN PetscClassId QPPF_CLASSID;

typedef enum {QPPF_A=0, QPPF_B=1} QPPFGDistribution;
FLLOP_EXTERN const char *QPPFGDistributions[];

typedef enum {QPPF_SEQ_ZERO=0, QPPF_SEQ_ALL=1, QPPF_DIST=2, QPPF_ORTH=3} QPPFVariant;
FLLOP_EXTERN const char *QPPFVariants[];

typedef struct _p_QPPF* QPPF;

FLLOP_EXTERN PetscErrorCode QPPFCreate(MPI_Comm comm, QPPF* cp);
FLLOP_EXTERN PetscErrorCode QPPFReset(QPPF cp);
FLLOP_EXTERN PetscErrorCode QPPFView(QPPF cp,PetscViewer v);
FLLOP_EXTERN PetscErrorCode QPPFSetUp(QPPF cp);
FLLOP_EXTERN PetscErrorCode QPPFSetFromOptions(QPPF cp);
FLLOP_EXTERN PetscErrorCode QPPFDestroy(QPPF *cp);

FLLOP_EXTERN PetscErrorCode QPPFApplyQ(QPPF cp, Vec v, Vec Qv);
FLLOP_EXTERN PetscErrorCode QPPFApplyCP(QPPF cp, Vec x, Vec y);

FLLOP_EXTERN PetscErrorCode QPPFSetG(QPPF cp, Mat G);
FLLOP_EXTERN PetscErrorCode QPPFSetVariant(QPPF cp,QPPFVariant variant);
FLLOP_EXTERN PetscErrorCode QPPFSetGDistribution(QPPF cp, QPPFGDistribution GDistType);
FLLOP_EXTERN PetscErrorCode QPPFSetGtDistribution(QPPF cp, QPPFGDistribution GtDistType);
FLLOP_EXTERN PetscErrorCode QPPFSetGOrthType(QPPF cp,MatOrthType orthType);
FLLOP_EXTERN PetscErrorCode QPPFSetRedundancy(QPPF cp,PetscInt nred);
FLLOP_EXTERN PetscErrorCode QPPFSetExplicitInv(QPPF cp,PetscBool explicitInv);

FLLOP_EXTERN PetscErrorCode QPPFGetQ(QPPF cp, Mat *Q);
FLLOP_EXTERN PetscErrorCode QPPFGetP(QPPF cp, Mat *P);
FLLOP_EXTERN PetscErrorCode QPPFGetHalfQ(QPPF cp, Mat *HalfQ);
FLLOP_EXTERN PetscErrorCode QPPFGetG(QPPF cp, Mat *G);
FLLOP_EXTERN PetscErrorCode QPPFGetGGt(QPPF cp, Mat *GGt);
FLLOP_EXTERN PetscErrorCode QPPFGetGGtinv(QPPF cp, Mat *GGtinv);
FLLOP_EXTERN PetscErrorCode QPPFGetKSP(QPPF cp, KSP *ksp);

#endif
