#if !defined(__QPIMPL_H)
#define	__QPIMPL_H
#include <fllopqp.h>

struct _p_QP {
  PETSCHEADER(int);
  Mat              A;
  Vec              b;
  Vec              x;
  Mat              BI;
  Vec              cI;
  Mat              BE;
  Vec              cE; 
  Vec              lb; 
  Vec              ub; 
  Mat              pmat;
  QP               parent,child;
  QPPF             pf;
  
  void             *changeListenerCtx;
  PetscErrorCode   (*changeListener)(QP);
  
  /* post-processing action after THIS QP's solve */
  void             *postSolveCtx;
  PetscErrorCode   (*postSolve)(QP thisQP,Vec x);
  PetscErrorCode   (*postSolveCtxDestroy)(void *postSolveCtx);
  void             (*transform)(void);
};

FLLOP_EXTERN PetscErrorCode QPTransformBegin(void(*transform)(void), QP *qp, QP *child, MPI_Comm *comm);
#endif
