#if !defined(__QPPFIMPL_H)
#define	__QPPFIMPL_H
#include <fllopqppf.h>

#define QPPF_DEFAULT_KSP_TYPE          KSPPREONLY
#define QPPF_DEFAULT_PC_TYPE           PCLU
#define QPPF_DEFAULT_MATSOLVER_PACKAGE MATSOLVERPETSC
#define QPPF_DEFAULT_RTOL              1e-6
#define QPPF_DEFAULT_ATOL              PETSC_DEFAULT
#define QPPF_DEFAULT_DTOL              PETSC_DEFAULT
#define QPPF_DEFAULT_MAXIT             PETSC_DEFAULT

#define QPPF_DEFAULT_G_DIST_TYPE       QPPF_B
#define QPPF_DEFAULT_GT_DIST_TYPE      QPPF_B
#define QPPF_DEFAULT_CP_VARIANT        QPPF_SEQ_ZERO
#define QPPF_DEFAULT_G_ORTH_TYPE       MAT_ORTH_GS


struct _p_QPPF {
    PETSCHEADER(int);
    
    Mat G, Gp, Gpt, GGtinv;
    PetscInt Gm,Gn,GM,GN;

    /* only to hold the solver's characteristics in explicit CP case */
    char kspType[MAX_NAME_LEN];
    char pcType[MAX_NAME_LEN];
    char matSolverPkg[MAX_NAME_LEN];
    PetscReal rtol;
    
    QPPFGDistribution GDistribution, GtDistribution;
    QPPFVariant cpVariant;
    MatOrthType GOrthType;
    PetscBool explicitInv, G_orthonormal_rows;
    PetscInt  redundancy;
    PetscReal GGt_relative_fill;

    PetscBool dataChange, variantChange, explicitInvChange, GChange;

    /* measurements */
    PetscInt it_GGtinvv;
    KSPConvergedReason conv_GGtinvv;
    
    /* preallocated stuff */
    Vec Gt_right;
    Vec G_left_seq;
    Vec G_left;
    Vec Gt_right_seq;
    VecScatter G_left_to_G_left_seq;

    Vec QPPFApplyQ_lastv, QPPFApplyQ_lastQv;
    
    struct _p_QPPF* cp_HalfQ;
};


FLLOP_EXTERN PetscLogEvent QPPF_SetUp, QPPF_SetUp_Gt, QPPF_SetUp_GGt, QPPF_SetUp_GGtinv;
FLLOP_EXTERN PetscLogEvent QPPF_ApplyCP, QPPF_ApplyCP_gt, QPPF_ApplyCP_sc;
FLLOP_EXTERN PetscLogEvent QPPF_ApplyQ, QPPF_ApplyG, QPPF_ApplyGt;

#endif
